      subroutine integ(p,delt,ttim,j1,j2,r1,r2,ips,itn,nd,r,v,
     &  eee,nerr)
c
c     Carry out the integral for delta & travel time by 
c	the eqs. (11) & (13).
c       Coded by T. Shibutani
c                1996-11-22
c		 1997-06-14
c
      parameter (ndmax=6400)
c
      implicit real*8 (a-h,o-z)
      dimension r(ndmax),v(ndmax,2)
c
      nerr=0
      delt=0.0
      ttim=0.0
c
c---  neighborhood of r1 (the deepest point)
c
      if (r(j1).eq.r(j1-1)) go to 100
      b=dlog(v(j1,ips)/v(j1-1,ips))/dlog(r(j1)/r(j1-1))
      if (1-b.le.eee) then
         nerr=1
         return
      else
         xu=r(j1-1)/v(j1-1,ips)
         if (itn.eq.1) then
            delt=dacos(p/xu)/(1-b)
            ttim=dsqrt(xu**2-p**2)/(1-b)
         else
            a=v(j1,ips)/r(j1)**b
            xl=r1**(1-b)/a
            delt=(dacos(p/xu)-dacos(p/xl))/(1-b)
            ttim=(dsqrt(xu**2-p**2)-dsqrt(xl**2-p**2))/(1-b)
         end if
      end if
c      write(6,*) 'b,a,xu,xl=',b,a,xu,xl
 100  continue
c
c---  from r1 to r2
c
      do 101 jd=j1-1,j2+1,-1
         if (r(jd).eq.r(jd-1)) go to 101
         b=dlog(v(jd,ips)/v(jd-1,ips))/dlog(r(jd)/r(jd-1))
         if (1-b.le.eee) then
            nerr=1
            return
         else
            xu=r(jd-1)/v(jd-1,ips)
            xl=r(jd)/v(jd,ips)
            delt=delt+(dacos(p/xu)-dacos(p/xl))/(1-b)
            ttim=ttim+(dsqrt(xu**2-p**2)-dsqrt(xl**2-p**2))/(1-b)
         end if
c         write(6,*) 'b,delt,ttim=',b,delt,ttim
 101  continue
c
c---  neighborhood of r2 (the shallowest point)
c
      b=dlog(v(j2,ips)/v(j2+1,ips))/dlog(r(j2)/r(j2+1))
      if (1-b.le.eee) then
         nerr=1
         return
      else
         xl=r(j2+1)/v(j2+1,ips)
         a=v(j2,ips)/r(j2)**b
         xu=r2**(1-b)/a
         delt=delt+(dacos(p/xu)-dacos(p/xl))/(1-b)
         ttim=ttim+(dsqrt(xu**2-p**2)-dsqrt(xl**2-p**2))/(1-b)
      end if
c      write(6,*) 'b,a,xu,xl=',b,a,xu,xl
c
      return
      end
