      subroutine tnray(del,tt,rt,p,r1,r2,ips,nd,r,v,eee,nerr)
c
c     Travel time for down-going ray
c       Coded by T. Shibutani
c       Ver. 1996-11-21
c
      parameter (ndmax=6400)
c
      implicit real*8 (a-h,o-z)
      dimension r(ndmax),v(ndmax,2)
c
c---  parameters
c
      pi=3.141592654
      deg=180.0/pi
      nerr=0
c
c---  layer of r1 & r2
c
      nu=1
      call uplyr(r1,j1,nu,nd,r)
      call uplyr(r2,j2,nu,nd,r)
c
c---  layer of turning point
c
      nu=min0(j1,j2)
      call tnlyr(p,rt,jt,nu,nd,r,v(1,ips),eee,nerr)
c      write(6,*) 'jt,rt=',jt,rt
      if (nerr.ne.0) return
c
c---  path integral
c
      itn=1
      call integ(p,deld,ttimd,jt,j1,rt,r1,ips,itn,nd,r,v,eee,nerr)
      call integ(p,delu,ttimu,jt,j2,rt,r2,ips,itn,nd,r,v,eee,nerr)
      if (nerr.ne.0) return
c
c---  delta
c
      delta=deld+delu
c      write(6,*) 'del=',delta*deg
      del=del+delta*deg
c
c---  travel time
c
c      write(6,*) 'tt=',ttimd+ttimu
      tt=tt+ttimd+ttimu
c
      return
      end

